package.path = package.path .. ";../wrapper/?.lua"

require 'spfab'

local function loadSp()
  NSSpLoad(1, ":a;test.png")
  NSSpMove(1, 320, 240, 255)
  local w, h = NSSpGetInfo(1)
  NSSpLoad(2, ":a;blend.png")
  NSSpVisible(2, false)
end

function NSCOM_main()
  local winX, winY = NSGetWindowSize()
  NSExec("bg #999999,1")
  NSSpLoad(0, ":a;test.png")
  NSSpMove(0, 320, 0, 255)
  NSInvalidate(0, 0, winX, winY)
  NSUpdate()
  NSClick()
  for i,func in ipairs({
      function() spfab.colorBy(0, 128, 128, 128) end, 
      function() spfab.flipX(0) end, 
      function() spfab.flipY(0) end,
      function() spfab.rotate(0, 30, true) end,
      function() spfab.zoom(0, 2.0, 2.0, true) end,
      function() spfab.zoom(0, 0.5, 0.5, true) end,
      function() spfab.rotate(0, 30) end,
      function() spfab.zoom(0, 2.0, 2.0) end,
      function() spfab.zoom(0, 0.5, 0.5) end,
      function() spfab.grayscale(0) end,
      function() spfab.monocro(0, 192) end,
      --function() spfab.alternate(1) end,
      function() loadSp();spfab.blend(1, 2, 1, 1, spfab.Alpha) end,
      function() loadSp();spfab.blend(1, 2, 1, 1, spfab.Add) end,
      function() loadSp();spfab.blend(1, 2, 1, 1, spfab.Sub) end,
      function() NSOkBox(spfab.version(), "version") end
    }) do
    func()
    local w, h = NSSpGetInfo(0)
    NSExec(('caption "size = %dx%d"'):format(w, h))
    NSInvalidate(0, 0, winX, winY)
    NSUpdate()
    NSClick()
  end
  NSOkBox(tostring(spfab.ptinopaque(0, 0, 0)), "ptinopaque 0,0") -- probably false
  local w, h = NSSpGetInfo(0)
  NSOkBox(tostring(spfab.ptinopaque(0, w/2, h/2)), "ptinopaque w/2, h/2") -- probably true
  NSEnd()
end
