--- spfab.lua
-- @author senzogawa
-- @release 2010/10/02 0.3.0

require 'nsspfab'
--[[ ȉƓľ
-- nsspfab_flipX(spnum)
NL_bind("nsspfab.dll", "nsspfab_flipX", "nsspfab_flipX")
-- nsspfab_flipY(spnum)
NL_bind("nsspfab.dll", "nsspfab_flipY", "nsspfab_flipY")
-- nsspfab_zoom(spnum, scaleX, scaleY[, autoresize])
NL_bind("nsspfab.dll", "nsspfab_zoom", "nsspfab_zoom")
-- nsspfab_colorBy(spnum, dr, dg, db)
NL_bind("nsspfab.dll", "nsspfab_colorBy", "nsspfab_colorBy")
-- nsspfab_rotate(spnum, degree[, autoresize])
NL_bind("nsspfab.dll", "nsspfab_rotate", "nsspfab_rotate")
-- nsspfab_grayscale(spnum)
NL_bind("nsspfab.dll", "nsspfab_grayscale", "nsspfab_grayscale")
-- nsspfab_monocro(spnum[, threshold[, lowwhite] ])
NL_bind("nsspfab.dll", "nsspfab_monocro", "nsspfab_monocro")
-- nsspfab_alternate(spnum)
NL_bind("nsspfab.dll", "nsspfab_alternate", "nsspfab_alternate")
-- nsspfab_ptinopaque(spnum, x, y[, cell])
NL_bind("nsspfab.dll", "nsspfab_ptinopaque", "nsspfab_ptinopaque")
-- nsspfab_blend(spnum, blendnum, x, y[, operation])
NL_bind("nsspfab.dll", "nsspfab_blend", "nsspfab_blend")
-- nsspfab_version()
NL_bind("nsspfab.dll", "nsspfab_version", "nsspfab_version")
]]

local nsspfab_flipX = nsspfab_flipX
local nsspfab_flipY = nsspfab_flipY
local nsspfab_zoom = nsspfab_zoom
local nsspfab_colorBy = nsspfab_colorBy
local nsspfab_rotate = nsspfab_rotate
local nsspfab_grayscale = nsspfab_grayscale
local nsspfab_monocro = nsspfab_monocro
local nsspfab_alternate = nsspfab_alternate
local nsspfab_ptinopaque = nsspfab_ptinopaque
local nsspfab_blend = nsspfab_blend
local nsspfab_version = nsspfab_version

local assert = assert

--- XvCgHp̊֐񋟂܂B
module('spfab')

--- At@
Alpha = "alpha"
--- Z
Add = "add"
--- Z
Sub = "sub"

--- XvCg摜𐅕ɔ]܂B
-- @param spnum XvCgԍ
function flipX(spnum)
  assert(spnum)
  nsspfab_flipX(spnum)
end


--- XvCg摜𐂒ɔ]܂B
-- @param spnum XvCgԍ
function flipY(spnum)
  assert(spnum)
  nsspfab_flipY(spnum)
end


--- XvCg摜gEk܂B
-- @param spnum XvCgԍ
-- @param zx ̊gk(1.0:̂܂)
-- @param zy ̊gk(1.0:̂܂)
-- @param autoresize true:TCYAfalse:Ȃ
function zoom(spnum, scaleX, scaleY, autoresize)
  assert(spnum)
  assert(scaleX)
  assert(scaleY)
  nsspfab_zoom(spnum, scaleX, scaleY, autoresize)
end


--- XvCg摜ɐFZ܂B
-- @param spnum XvCgԍ
-- @param dr ZԐ
-- @param dg Zΐ
-- @param db Z
function colorBy(spnum, dr, dg, db)
  assert(spnum)
  assert(dr)
  assert(dg)
  assert(db)
  nsspfab_colorBy(spnum, dr, dg, db)
end


--- XvCg摜]܂B
-- @param spnum XvCgԍ
-- @param degree ]px(360x@)
-- @param autoresize true:TCYAfalse:Ȃ
function rotate(spnum, degree, autoresize)
  assert(spnum)
  assert(degree)
  nsspfab_rotate(spnum, degree, autoresize)
end


--- XvCg摜𔒍256Kɂ܂B
-- @param spnum XvCgԍ
function grayscale(spnum)
  assert(spnum)
  nsspfab_grayscale(spnum)
end


--- XvCg摜XvCg摜臒lŔɓh蕪܂B
-- @param spnum XvCgԍ
-- @param threshold 臒l(臒l>RGBϒlȂ獕,臒l<=RGBϒlȂ甒)
-- @param lowwhite truȅꍇA臒l>RGBϒl̏ꍇ𔒂ƂB
function monocro(spnum, threshold, lowwhite)
  assert(spnum)
  nsspfab_monocro(spnum, threshold, lowwhite)
end


--- XvCg摜̃}XNĔzu܂B
-- nscrpng.spi𗘗pꍇANScripter̉摜vOC̎dl̂߁A<br/>
-- ZƂo܂B<br/>
-- ̖߂gpƁAZ悤ɍĔzu܂B<br/>
-- nspng.dll𗘗pꍇ͕Kv܂B<br/>
-- )<br/>
-- F摜AF}XN<br/>
--   <br/>
-- @param spnum XvCgԍ
function alternate(spnum)
  assert(spnum)
  nsspfab_alternate(spnum)
end


--- XvCg摜̎wʒu̕s߂mF܂B
-- @param spnum XvCgԍ
-- @param x ΏۂXW
-- @param y ΏۂYW
-- @param cell Zԍ(ȗ0)
-- @return true:s߁Afalse:
function ptinopaque(spnum, x, y, cell)
  assert(spnum)
  assert(x)
  assert(y)
  return nsspfab_ptinopaque(spnum, x, y, cell)
end


--- XvCg摜ɕʂ̃XvCg摜܂B
-- @param spnum XvCgԍ
-- @param blendnum pXvCgԍ
-- @param x XW
-- @param y YW
-- @param operation ("alpha"(ftHg),"add","sub"̂ꂩw)
-- @return true:Afalse:s
function blend(spnum, blendnum, x, y, operation)
  assert(spnum)
  assert(blendnum)
  return nsspfab_blend(spnum, blendnum, x or 0, y or 0, operation)
end


-- vOC̃o[WԂ܂B
-- @return "X.X.X"
function version()
  return nsspfab_version()
end
